-- database operations
module Main(main) where

import TerraHS

host = "localhost";
dbname =  "rondonia";
user = "root";
password = "root";

layername ="layer_in";


main:: IO()
main = do

	-- open a database connection
	db <- open (TeMySQL host user password dbname)
	
	-- load a geo-objcets set from a layer
	go <- (retrieve db layername)::(IO [TeGeoObject]) 
	
	-- save geo-object in a new layer
	store db "layer_out" go
	
	-- close connection
	close db
	print "rodou"
	
	
	